<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: ILut Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li><a href="classes.xhtml"><span>Data&#160;Structure&#160;Index</span></a></li>
      <li><a href="inherits.xhtml"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.xhtml"><span>Data&#160;Fields</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classarm__compute_1_1_i_lut.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">ILut Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Lookup Table object interface.  
 <a href="classarm__compute_1_1_i_lut.xhtml#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_i_lut_8h_source.xhtml">ILut.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab90dd1556851ce4b6b1529dfb9107f68"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_i_lut.xhtml#ab90dd1556851ce4b6b1529dfb9107f68">~ILut</a> ()=default</td></tr>
<tr class="memdesc:ab90dd1556851ce4b6b1529dfb9107f68"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default virtual destructor.  <a href="#ab90dd1556851ce4b6b1529dfb9107f68">More...</a><br /></td></tr>
<tr class="separator:ab90dd1556851ce4b6b1529dfb9107f68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a826fbb4f639c556352d1ede69187d7"><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_i_lut.xhtml#a7a826fbb4f639c556352d1ede69187d7">num_elements</a> () const =0</td></tr>
<tr class="memdesc:a7a826fbb4f639c556352d1ede69187d7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total number of elements in the LUT.  <a href="#a7a826fbb4f639c556352d1ede69187d7">More...</a><br /></td></tr>
<tr class="separator:a7a826fbb4f639c556352d1ede69187d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a786de36dda3773c5fb35d6700e64621e"><td class="memItemLeft" align="right" valign="top">virtual uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_i_lut.xhtml#a786de36dda3773c5fb35d6700e64621e">index_offset</a> () const =0</td></tr>
<tr class="memdesc:a786de36dda3773c5fb35d6700e64621e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicates the offset that needs to be applied to the raw index before performing a lookup in the LUT.  <a href="#a786de36dda3773c5fb35d6700e64621e">More...</a><br /></td></tr>
<tr class="separator:a786de36dda3773c5fb35d6700e64621e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6314b1e589ffe32277858c018ac3c630"><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_i_lut.xhtml#a6314b1e589ffe32277858c018ac3c630">size_in_bytes</a> () const =0</td></tr>
<tr class="memdesc:a6314b1e589ffe32277858c018ac3c630"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total size in bytes of the LUT.  <a href="#a6314b1e589ffe32277858c018ac3c630">More...</a><br /></td></tr>
<tr class="separator:a6314b1e589ffe32277858c018ac3c630"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa1917b40b57ce0a0f1c69722b46f3f46"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespacearm__compute.xhtml#ad8ed01ff3ff33333d8e19db4d2818bb6">DataType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_i_lut.xhtml#aa1917b40b57ce0a0f1c69722b46f3f46">type</a> () const =0</td></tr>
<tr class="memdesc:aa1917b40b57ce0a0f1c69722b46f3f46"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the type of the LUT.  <a href="#aa1917b40b57ce0a0f1c69722b46f3f46">More...</a><br /></td></tr>
<tr class="separator:aa1917b40b57ce0a0f1c69722b46f3f46"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab988210662dbd3bf32fd563c7dd1bdbf"><td class="memItemLeft" align="right" valign="top">virtual uint8_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_i_lut.xhtml#ab988210662dbd3bf32fd563c7dd1bdbf">buffer</a> () const =0</td></tr>
<tr class="memdesc:ab988210662dbd3bf32fd563c7dd1bdbf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the start of the LUT.  <a href="#ab988210662dbd3bf32fd563c7dd1bdbf">More...</a><br /></td></tr>
<tr class="separator:ab988210662dbd3bf32fd563c7dd1bdbf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5eeb94d22b8366d1b68d0614384802fe"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_i_lut.xhtml#a5eeb94d22b8366d1b68d0614384802fe">clear</a> ()=0</td></tr>
<tr class="memdesc:a5eeb94d22b8366d1b68d0614384802fe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears the LUT by setting every element to zero.  <a href="#a5eeb94d22b8366d1b68d0614384802fe">More...</a><br /></td></tr>
<tr class="separator:a5eeb94d22b8366d1b68d0614384802fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Lookup Table object interface. </p>

<p>Definition at line <a class="el" href="_i_lut_8h_source.xhtml#l00034">34</a> of file <a class="el" href="_i_lut_8h_source.xhtml">ILut.h</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ab90dd1556851ce4b6b1529dfb9107f68"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual ~<a class="el" href="classarm__compute_1_1_i_lut.xhtml">ILut</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Default virtual destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ab988210662dbd3bf32fd563c7dd1bdbf"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual uint8_t* buffer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a pointer to the start of the LUT. </p>
<p>Other elements of the LUT can be accessed using <a class="el" href="classarm__compute_1_1_i_lut.xhtml#ab988210662dbd3bf32fd563c7dd1bdbf" title="Returns a pointer to the start of the LUT. ">buffer()</a>[idx] for 0 &lt;= idx &lt; <a class="el" href="classarm__compute_1_1_i_lut.xhtml#a7a826fbb4f639c556352d1ede69187d7" title="Returns the total number of elements in the LUT. ">num_elements()</a>.</p>
<dl class="section return"><dt>Returns</dt><dd>Pointer to the start of the lut. </dd></dl>

<p>Implemented in <a class="el" href="classarm__compute_1_1_i_c_l_lut.xhtml#ace7b855e3c647d29cc37a1ce147901dc">ICLLut</a>, and <a class="el" href="classarm__compute_1_1_lut.xhtml#ace7b855e3c647d29cc37a1ce147901dc">Lut</a>.</p>

</div>
</div>
<a class="anchor" id="a5eeb94d22b8366d1b68d0614384802fe"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void clear </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Clears the LUT by setting every element to zero. </p>

<p>Implemented in <a class="el" href="classarm__compute_1_1_c_l_lut.xhtml#aee7cb2065b88d21ac4ad05bc997ecf82">CLLut</a>, and <a class="el" href="classarm__compute_1_1_lut.xhtml#aee7cb2065b88d21ac4ad05bc997ecf82">Lut</a>.</p>

</div>
</div>
<a class="anchor" id="a786de36dda3773c5fb35d6700e64621e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual uint32_t index_offset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Indicates the offset that needs to be applied to the raw index before performing a lookup in the LUT. </p>
<dl class="section return"><dt>Returns</dt><dd>The normalization offset. </dd></dl>

<p>Implemented in <a class="el" href="classarm__compute_1_1_c_l_lut.xhtml#aaf3f51cd25e1651cccf04064a9888f4e">CLLut</a>, and <a class="el" href="classarm__compute_1_1_lut.xhtml#aaf3f51cd25e1651cccf04064a9888f4e">Lut</a>.</p>

</div>
</div>
<a class="anchor" id="a7a826fbb4f639c556352d1ede69187d7"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t num_elements </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the total number of elements in the LUT. </p>
<dl class="section return"><dt>Returns</dt><dd>Total number of elements. </dd></dl>

<p>Implemented in <a class="el" href="classarm__compute_1_1_c_l_lut.xhtml#a6dac829b4ddf4a5729ac090e73696958">CLLut</a>, and <a class="el" href="classarm__compute_1_1_lut.xhtml#a6dac829b4ddf4a5729ac090e73696958">Lut</a>.</p>

</div>
</div>
<a class="anchor" id="a6314b1e589ffe32277858c018ac3c630"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual size_t size_in_bytes </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the total size in bytes of the LUT. </p>
<dl class="section return"><dt>Returns</dt><dd>Total size of the LUT in bytes. </dd></dl>

<p>Implemented in <a class="el" href="classarm__compute_1_1_c_l_lut.xhtml#a68f33e9afee896dc24b32093d25c6766">CLLut</a>, and <a class="el" href="classarm__compute_1_1_lut.xhtml#a68f33e9afee896dc24b32093d25c6766">Lut</a>.</p>

</div>
</div>
<a class="anchor" id="aa1917b40b57ce0a0f1c69722b46f3f46"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespacearm__compute.xhtml#ad8ed01ff3ff33333d8e19db4d2818bb6">DataType</a> type </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the type of the LUT. </p>
<dl class="section return"><dt>Returns</dt><dd>The type of the LUT. </dd></dl>

<p>Implemented in <a class="el" href="classarm__compute_1_1_c_l_lut.xhtml#a6dc9c052a2732f899adccfaeee468364">CLLut</a>, and <a class="el" href="classarm__compute_1_1_lut.xhtml#a6dc9c052a2732f899adccfaeee468364">Lut</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>arm_compute/core/<a class="el" href="_i_lut_8h_source.xhtml">ILut.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacearm__compute.xhtml">arm_compute</a></li><li class="navelem"><a class="el" href="classarm__compute_1_1_i_lut.xhtml">ILut</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:10 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
